## dde-control-center 6.0.71

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

set(DVERSION "6.0.44" CACHE STRING "define project version")
set(BUILD_DOCS OFF CACHE BOOL "Generate doxygen-based documentation")

set(PROJECT_NAME dde-control-center)
project(${PROJECT_NAME}
    VERSION ${DVERSION}
    DESCRIPTION "Deepin Control Center"
    HOMEPAGE_URL "https://github.com/linuxdeepin/dde-control-center"
    LANGUAGES CXX C
)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
option(ENABLE_ASAN "Enable asan" OFF)
option(BUILD_TESTING "UNIT test" OFF)

# dcc-v23
set(BUILD_DCC_OLD ON CACHE BOOL "build old dcc")
if (BUILD_DCC_OLD)
    add_subdirectory(dcc-old)
endif()

set(QT_NS Qt6)
set(DTK_NS Dtk6)
set(ASQT_NS AppStreamQt)

# 设置静态库文件目录
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
# 动态库文件目录
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
# 可执行文件目录
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)


# INFO:
# plugins can be disabled and their options
# plugin-authentication : DISABLE_AUTHENTICATION
# plugin-update : DISABLE_UPDATE
# plugin-keyboard: DISABLE_LANGUAGE to disable language panel

option(DISABLE_AUTHENTICATION "disable build authentication plugins" OFF)
option(DISABLE_UPDATE "disable build update plugins" OFF)
option(DISABLE_LANGUAGE "disable lanugage settings in control center" OFF)
option(USE_DEEPIN_ZONE "enable special timezone file on deepin" OFF)
option(DISABLE_SOUND_ADVANCED "disable sound advanced settings" OFF)
set(DEEPIN_TIME_ZONE_PATH "/usr/share/dde/zoneinfo/zone1970.tab" CACHE STRING "deepin timezone path")
set(LOCALE_I18N_PATH "/usr/share/i18n/SUPPORTED" CACHE STRING "Supported locale path")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/misc;${CMAKE_MODULE_PATH};${ECM_MODULE_PATH};${PROJECT_SOURCE_DIR}/misc")
include(DdeControlCenterPluginMacros)

# asan 自己有内存泄露，暂不使用
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(UNITTEST ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Werror=return-type -fno-omit-frame-pointer -Wextra")
    if(ENABLE_ASAN)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
        add_definitions(-DUSE_ASAN)
    endif()
else()
    # generate qm
    execute_process(COMMAND bash "misc/translate_generation.sh" "${CMAKE_CURRENT_BINARY_DIR}/src/dde-control-center"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
    # generate desktop translate
    execute_process(COMMAND bash "misc/translate_ts2desktop.sh"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif()

if (BUILD_TESTING)
    set(UNITTEST ON)
endif()

set(BUILD_PLUGIN ON)

if (NOT BUILD_PLUGIN)
    set(UNITTEST OFF)
endif()
# GNU 默认

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(UT_COMPILER -fprofile-arcs -ftest-coverage)
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(UT_COMPILER -fprofile-instr-generate -ftest-coverage)
endif()

if (USE_DEEPIN_ZONE)
    add_definitions(-DUSE_DEEPIN_ZONE)
    add_definitions(-DDEEPIN_TIME_ZONE_PATH="${DEEPIN_TIME_ZONE_PATH}")
endif ()

add_definitions(-DLOCALE_I18N_PATH="${LOCALE_I18N_PATH}")

# 增加安全编译参数
ADD_DEFINITIONS(${SAFE_COMPILER})

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(GoogleTest)

if(BUILD_DOCS)
    add_subdirectory(docs)
endif()

set(DCC_TRANSLATION_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/translations/v1.0" CACHE STRING "Install dir for dde-control-center translate files")

# 输出目录
set(DCC_LIBDIR ${PROJECT_BINARY_DIR}/lib)
# 插件目录
set(DCC_PLUGINS_DIR plugins_v1.0)
# 安装目录
set(DCC_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/dde-control-center)
set(DCC_PREFIX "")
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(DCC_DEBUG_LIBDIR ${DCC_LIBDIR})
    set(DCC_TRANSLATE_READ_DIR ${PROJECT_BINARY_DIR}/src/dde-control-center)
else()
    set(DCC_DEBUG_LIBDIR ${DCC_INSTALL_DIR})
    set(DCC_PREFIX "/usr/")
    set(DCC_TRANSLATE_READ_DIR ${CMAKE_INSTALL_PREFIX}/${DCC_TRANSLATION_INSTALL_DIR})
endif()

add_definitions(-DTRANSLATE_READ_DIR="${DCC_TRANSLATE_READ_DIR}")
# 插件安装目录
set(DCC_PLUGINS_INSTALL_DIR ${DCC_DEBUG_LIBDIR}/${DCC_PLUGINS_DIR} CACHE STRING "Install dir for dde-control-center plugins")
# 插件读取目录
set(MODULE_READ_DIR "${DCC_PREFIX}${DCC_DEBUG_LIBDIR}" CACHE STRING "Dir to find dde-control-center modules")
set(PLUGINS_READ_DIR "${DCC_PREFIX}${DCC_PLUGINS_INSTALL_DIR}" CACHE STRING "Dir to find dde-control-center plugins")

add_definitions(-DDefaultModuleDirectory="${MODULE_READ_DIR}")
add_definitions(-DDefaultPluginsDirectory="${PLUGINS_READ_DIR}")

# DdeControlCenterPluginMacros.cmake 使用
set(DDE_CONTROL_CENTER_PLUGIN_DIR ${DCC_PLUGINS_DIR})
set(DDE_CONTROL_CENTER_TRANSLATION_INSTALL_DIR ${DCC_TRANSLATION_INSTALL_DIR})
set(DDE_CONTROL_CENTER_PLUGIN_INSTALL_DIR ${DCC_PLUGINS_INSTALL_DIR})

set(LOCALSTATE_READ_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}" CACHE STRING "Dir to find modifiable single-machine data")
set(DCC_PROJECT_ROOT_DIR ${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DVARDIRECTORY="${LOCALSTATE_READ_DIR}")
# Find the library
find_package(PkgConfig REQUIRED)
find_package(${DTK_NS} REQUIRED COMPONENTS Core Gui  )
find_package(${QT_NS} COMPONENTS Core Quick Gui Network DBus Concurrent Test LinguistTools REQUIRED)
find_package(GTest REQUIRED)
find_package(Threads REQUIRED)

if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()

# dconfig
file(GLOB DCONFIG_FILES "misc/configs/*.json")
dtk_add_config_meta_files(APPID org.deepin.dde.control-center BASE misc/configs FILES ${DCONFIG_FILES})
file(GLOB DCONFIG_FILE_REGION_FORMAT "misc/configs/common/org.deepin.region-format.json")
dtk_add_config_meta_files(COMMONID true FILES ${DCONFIG_FILE_REGION_FORMAT})

include_directories(
    include
)

set(Test_Libraries
    -lgcov
    Threads::Threads
    GTest::gtest
    Qt::Test
)

add_subdirectory(src/dde-control-center)
#--------------------------plugins--------------------------
add_subdirectory(src/plugin-sound)
add_subdirectory(src/plugin-defaultapp)
add_subdirectory(src/plugin-power)
add_subdirectory(src/plugin-mouse)
add_subdirectory(src/plugin-personalization)
add_subdirectory(src/plugin-keyboard)
add_subdirectory(src/plugin-systeminfo)
add_subdirectory(src/plugin-commoninfo)
add_subdirectory(src/plugin-touchscreen)
add_subdirectory(src/plugin-datetime)
add_subdirectory(src/plugin-wacom)

=== dcc-old/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

set(DVERSION "6.0.44" CACHE STRING "define project version")
set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")

set(PROJECT_NAME dde-control-center-old)
project(${PROJECT_NAME}
    VERSION ${DVERSION}
    DESCRIPTION "Deepin Control Center"
    HOMEPAGE_URL "https://github.com/linuxdeepin/dde-control-center"
    LANGUAGES CXX C
)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
option(ENABLE_ASAN "Enable asan" OFF)
option(BUILD_TESTING "UNIT test" OFF)

# INFO:
# plugins can be disabled and their options
# plugin-authentication : DISABLE_AUTHENTICATION
# plugin-update : DISABLE_UPDATE
# plugin-keyboard: DISABLE_LANGUAGE to disable language panel

option(DISABLE_AUTHENTICATION "disable build authentication plugins" OFF)
option(DISABLE_UPDATE "disable build update plugins" OFF)
option(DISABLE_LANGUAGE "disable lanugage settings in control center" OFF)
option(USE_DEEPIN_ZONE "enable special timezone file on deepin" OFF)
option(DISABLE_SOUND_ADVANCED "disable sound advanced settings" OFF)
set(DEEPIN_TIME_ZONE_PATH "/usr/share/dde/zoneinfo/zone1970.tab" CACHE STRING "deepin timezone path")
set(LOCALE_I18N_PATH "/usr/share/i18n/SUPPORTED" CACHE STRING "Supported locale path")

# asan 自己有内存泄露，暂不使用
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    # set(UNITTEST ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Werror=return-type -fno-omit-frame-pointer -Wextra")
    if(ENABLE_ASAN)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
        add_definitions(-DUSE_ASAN)
    endif()
else()
    # generate qm
    execute_process(COMMAND bash "misc/translate_generation.sh"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
    # generate desktop translate
    execute_process(COMMAND bash "misc/translate_ts2desktop.sh"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif()

if (BUILD_TESTING)
    set(UNITTEST ON)
endif()

set(BUILD_PLUGIN ON)

if (NOT BUILD_PLUGIN)
    set(UNITTEST OFF)
endif()
# GNU 默认

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(UT_COMPILER -fprofile-arcs -ftest-coverage)
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(UT_COMPILER -fprofile-instr-generate -ftest-coverage)
endif()

if (USE_DEEPIN_ZONE)
    add_definitions(-DUSE_DEEPIN_ZONE)
    add_definitions(-DDEEPIN_TIME_ZONE_PATH="${DEEPIN_TIME_ZONE_PATH}")
endif ()

add_definitions(-DLOCALE_I18N_PATH="${LOCALE_I18N_PATH}")

# 增加安全编译参数
ADD_DEFINITIONS(${SAFE_COMPILER})

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(GoogleTest)

if(BUILD_DOCS)
    add_subdirectory(docs)
endif()

set(TRANSLATE_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/dde-control-center/translations" CACHE STRING "Install dir for dde-control-center translate files")

add_definitions(-DTRANSLATE_READ_DIR="${CMAKE_INSTALL_PREFIX}/${TRANSLATE_INSTALL_DIR}")
set(MODULE_INSTALL_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/dde-control-center/modules" CACHE STRING "Install dir for dde-control-center modules")

set(DCC_MODULE_READ_DIR "${MODULE_INSTALL_DIR}" CACHE STRING "Dir to find dde-control-center modules")
add_definitions(-DDCC_DefaultModuleDirectory="${DCC_MODULE_READ_DIR}")

set(LOCALSTATE_READ_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}" CACHE STRING "Dir to find modifiable single-machine data")
add_definitions(-DVARDIRECTORY="${LOCALSTATE_READ_DIR}")
# Find the library
find_package(PkgConfig REQUIRED)
find_package(Dtk COMPONENTS Core Widget DConfig REQUIRED)
find_package(Qt5 COMPONENTS Widgets Network DBus Concurrent Multimedia Svg Test REQUIRED)
find_package(GTest REQUIRED)
find_package(Threads REQUIRED)
# pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()

# dconfig
# file(GLOB DCONFIG_FILES "misc/configs/*.json")
# dtk_add_config_meta_files(APPID org.deepin.dde.control-center BASE misc/configs FILES ${DCONFIG_FILES})
# file(GLOB DCONFIG_FILE_REGION_FORMAT "misc/configs/common/org.deepin.region-format.json")
# dtk_add_config_meta_files(COMMONID true FILES ${DCONFIG_FILE_REGION_FORMAT})

include_directories(
    include
)

set(Test_Libraries
    -lgcov
    Threads::Threads
    GTest::gtest
    Qt::Test
)

#--------------------------interface--------------------------
set(Interface_Name dcc-interface)
file(GLOB_RECURSE Interface_SRCS
    "include/interface/*.h"
    "src/interface/*.cpp"
)
add_library(${Interface_Name} SHARED
    ${Interface_SRCS}
)

set(Interface_Libraries
    Qt::Widgets
    Dtk::Widget
)

target_include_directories(${Interface_Name} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/interface>
)

target_include_directories(${Interface_Name} INTERFACE
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center/>
)

target_link_libraries(${Interface_Name} PUBLIC
    ${Interface_Libraries}
)

set_target_properties(${Interface_Name} PROPERTIES
    VERSION 6
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    EXPORT_NAME DCCInterface
)

# so
install(TARGETS ${Interface_Name}
        EXPORT DdeControlCenterInterfaceTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(EXPORT DdeControlCenterInterfaceTargets
        FILE DdeControlCenterInterfaceTargets.cmake
        NAMESPACE Dde::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
)


#--------------------------dccwidgets library----------------------------
set(Dcc_Widgets_Name dcc-widgets)
file(GLOB_RECURSE Dcc_Widgets_SRCS
    "include/widgets/*.h"
    "src/widgets/*.cpp"
)
add_library(${Dcc_Widgets_Name} SHARED
    ${Dcc_Widgets_SRCS}
)
set(Dcc_Widgets_Includes
    include/widgets
)

set(Dcc_Widgets_Libraries_public
    Dtk::Widget
    Qt::Widgets
    ${Interface_Name}
)

set(Dcc_Widgets_Libraries_private
    Qt::Svg
    Qt::DBus
)

set(Dcc_Widgets_Libraries
    ${Dcc_Widgets_Libraries_public}
    ${Dcc_Widgets_Libraries_private}
)

target_include_directories(${Dcc_Widgets_Name} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/widgets>
)

target_include_directories(${Dcc_Widgets_Name} INTERFACE
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center/>
)

target_link_libraries(${Dcc_Widgets_Name} PUBLIC
    ${Dcc_Widgets_Libraries_public}
)

target_link_libraries(${Dcc_Widgets_Name} PRIVATE
    ${Dcc_Widgets_Libraries_private}
)

set_target_properties(${Dcc_Widgets_Name} PROPERTIES
    VERSION 6
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    EXPORT_NAME DCCWidget
)

# so
install(TARGETS ${Dcc_Widgets_Name}
        EXPORT DdeControlCenterWidgetTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(EXPORT DdeControlCenterWidgetTargets
        FILE DdeControlCenterWidgetTargets.cmake
        NAMESPACE Dde::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
)


#------------------------dccwidgets library test--------------------------
if (UNITTEST)
    set(UT_Dcc_Widgets_Name ut-dcc-widgets)
    file(GLOB_RECURSE UT_Dcc_Widgets_SRCS
        "tests/widgets/*.cpp"
    )
    add_executable(${UT_Dcc_Widgets_Name}
        ${Dcc_Widgets_SRCS}
        ${UT_Dcc_Widgets_SRCS}
    )
    # 用于测试覆盖率的编译条件
    target_compile_options(${UT_Dcc_Widgets_Name} PRIVATE ${UT_COMPILER})
    target_include_directories(${UT_Dcc_Widgets_Name} PUBLIC
        ${Dcc_Widgets_Includes}
    )
    target_link_libraries(${UT_Dcc_Widgets_Name} PRIVATE
        ${Dcc_Widgets_Libraries}
        ${Test_Libraries}
    )
    gtest_discover_tests(${UT_Dcc_Widgets_Name} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
endif()

#--------------------------dde-control-center-Agent--------------------------
set(DCC_AGENT_PREFIX "")
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(OLD_DCC_SO_PATH ${PROJECT_BINARY_DIR}/../dcc-old/libdcc-widgets.so)
    set(NEW_DCC_SO_PATH ${PROJECT_BINARY_DIR}/../lib/libdde-control-center.so)
    set(OLD_DCC_PATH ${PROJECT_BINARY_DIR}/../dcc-old/libdde-control-center-old.so)
    set(NEW_DCC_PATH ${PROJECT_BINARY_DIR}/../lib/libdde-control-center-lib.so)
else()
    set(DCC_AGENT_PREFIX "/usr/")
    set(OLD_DCC_SO_PATH ${CMAKE_INSTALL_LIBDIR}/libdcc-widgets.so)
    set(NEW_DCC_SO_PATH ${CMAKE_INSTALL_LIBDIR}/libdde-control-center.so)
    set(OLD_DCC_PATH ${CMAKE_INSTALL_LIBDIR}/dde-control-center/libdde-control-center-old.so)
    set(NEW_DCC_PATH ${CMAKE_INSTALL_LIBDIR}/dde-control-center/libdde-control-center-lib.so)
    set(DCC_TRANSLATE_READ_DIR ${CMAKE_INSTALL_PREFIX}/${DCC_TRANSLATION_INSTALL_DIR})
endif()
add_definitions(-DOLD_DCC_SO_PATH="${DCC_AGENT_PREFIX}${OLD_DCC_SO_PATH}")
add_definitions(-DNEW_DCC_SO_PATH="${DCC_AGENT_PREFIX}${NEW_DCC_SO_PATH}")
add_definitions(-DOLD_DCC_PATH="${DCC_AGENT_PREFIX}${OLD_DCC_PATH}")
add_definitions(-DNEW_DCC_PATH="${DCC_AGENT_PREFIX}${NEW_DCC_PATH}")


set(DCC_Agent dde-control-center-agent)
set(DCCAgent_Name ${DCC_Agent})
file(GLOB DCCAgent_SRCS
    "src/dcc-agent/*.c"
)

add_executable(${DCCAgent_Name}
    ${DCCAgent_SRCS}
)

set_target_properties(${DCCAgent_Name} PROPERTIES
    OUTPUT_NAME dde-control-center
)

install(TARGETS ${DCCAgent_Name} DESTINATION ${CMAKE_INSTALL_BINDIR})

#--------------------------dde-control-center--------------------------
set(Control_Center_Name dde-control-center-old)
file(GLOB_RECURSE Control_Center_SRCS
    "src/frame/*.h"
    "src/frame/*.cpp"
)
list(REMOVE_ITEM Control_Center_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/src/frame/main.cpp")

add_library(${Control_Center_Name} SHARED
    ${Control_Center_SRCS}
    src/frame/main.cpp
)

target_compile_definitions(${Control_Center_Name} PRIVATE CVERSION="${CVERSION}")

set(Control_Center_Libraries
    ${Dcc_Widgets_Name}
    ${Interface_Name}
    Dtk::Widget
    Qt::Widgets
    Qt::DBus
    Qt::Concurrent
)

target_link_libraries(${Control_Center_Name} PRIVATE
    ${Control_Center_Libraries}
)

# bin
install(TARGETS ${Control_Center_Name} DESTINATION ${CMAKE_INSTALL_LIBDIR}/dde-control-center/)

#----------------------------install config------------------------------
# qm files
file(GLOB QM_FILES "translations/*.qm")
install(FILES ${QM_FILES} DESTINATION ${TRANSLATE_INSTALL_DIR})

#desktop
# install(FILES misc/org.deepin.dde.control-center.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

#service
# configure_file(
#     ${CMAKE_CURRENT_SOURCE_DIR}/misc/org.deepin.dde.ControlCenter1.service.in
#     ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.ControlCenter1.service
#     @ONLY)
# install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.ControlCenter1.service
#         DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dbus-1/services)

# systemd service
if (NOT DEFINED SYSTEMD_USER_UNIT_DIR)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(Systemd REQUIRED systemd)
    pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
endif()

# configure_file(
#     ${CMAKE_SOURCE_DIR}/misc/systemd/dde-control-center.service.in
#     ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.control-center.service
#     @ONLY)

# install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.control-center.service
#         DESTINATION ${SYSTEMD_USER_UNIT_DIR})

# dev files
file(GLOB HEADERS "include/*")
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center)
install(DIRECTORY ${HEADERS} DESTINATION ${INCLUDE_INSTALL_DIR})

# configure_package_config_file(misc/DdeControlCenterConfig.cmake.in
#     ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
#     INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
#     PATH_VARS INCLUDE_INSTALL_DIR
#     INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

# write_basic_package_version_file(
#     "${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfigVersion.cmake"
#     VERSION ${PROJECT_VERSION}
#     COMPATIBILITY SameMajorVersion
# )

# install(FILES ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake

=== src/dde-control-center/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

#--------------------------frame--------------------------
set(DCC_Library dde-control-center_frame)
set(DCCFrame_Name ${DCC_Library})
file(GLOB DCCFrame_SRCS
    "${DCC_PROJECT_ROOT_DIR}/include/*.h"
    "frame/*.cpp"
)

add_library(${DCCFrame_Name} SHARED
    ${DCCFrame_SRCS}
)

find_package(${QT_NS} COMPONENTS QmlModels REQUIRED)
set(DCCFrame_Libraries
    ${DTK_NS}::Gui
    ${QT_NS}::Gui
    ${QT_NS}::Quick
    ${QT_NS}::QmlModelsPrivate
)

target_link_libraries(${DCCFrame_Name} PRIVATE
    ${DCCFrame_Libraries}
)

set_target_properties(${DCCFrame_Name} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    OUTPUT_NAME dde-control-center
    EXPORT_NAME Control-Center
)

install(TARGETS ${DCCFrame_Name}
        EXPORT DdeControlCenterTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center
)

install(EXPORT DdeControlCenterTargets
        FILE DdeControlCenterTargets.cmake
        NAMESPACE Dde::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
)
#--------------------------qml-plugin--------------------------
add_subdirectory(frame/plugin)
#--------------------------dde-control-center--------------------------
set(Control_Center_Name dde-control-center)
file(GLOB Control_Center_SRCS
    "*.h"
    "*.cpp"
)
if (BUILD_DCC_OLD)
    add_library(${Control_Center_Name} SHARED
        ${Control_Center_SRCS}
        qrc/dcc.qrc
    )
    set_target_properties(${Control_Center_Name} PROPERTIES
        OUTPUT_NAME dde-control-center-lib
    )
else()
    add_executable(${Control_Center_Name}
        ${Control_Center_SRCS}
        qrc/dcc.qrc
    )
endif()

target_compile_definitions(${Control_Center_Name} PRIVATE CVERSION="${CMAKE_PROJECT_VERSION}")

target_include_directories(${Control_Center_Name} PRIVATE
    include/interface
    frame
)

set(Control_Center_Libraries
    ${DCC_Library}
    ${DTK_NS}::Gui
    Qt::Gui
    Qt::DBus
    Qt::Concurrent
    Qt::Quick
)

target_link_libraries(${Control_Center_Name} PRIVATE
    ${Control_Center_Libraries}
)

file(GLOB_RECURSE qmlFiles  "${DCC_PROJECT_ROOT_DIR}/qml/*.*")
add_custom_target(${Control_Center_Name}_qml ALL
    SOURCES ${qmlFiles}
)
add_custom_command(TARGET ${Control_Center_Name}_qml
    COMMAND ${CMAKE_COMMAND} -E copy_directory "${DCC_PROJECT_ROOT_DIR}/qml" ${DCC_LIBDIR}
)

dcc_handle_plugin_translation(NAME ${Control_Center_Name} SOURCE_DIR ${DCC_PROJECT_ROOT_DIR})
# bin
if (BUILD_DCC_OLD)
    install(TARGETS ${Control_Center_Name} DESTINATION ${DCC_DEBUG_LIBDIR})
else()
    install(TARGETS ${Control_Center_Name} DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()
install(DIRECTORY "${DCC_PROJECT_ROOT_DIR}/qml/" DESTINATION ${DCC_INSTALL_DIR})
#----------------------------install config------------------------------
#desktop
install(FILES ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde.control-center.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

#service
configure_file(
    ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde.ControlCenter1.service.in
    ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.ControlCenter1.service
    @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.ControlCenter1.service
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dbus-1/services)

# systemd service
if (NOT DEFINED SYSTEMD_USER_UNIT_DIR)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(Systemd REQUIRED systemd)
    pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
endif()

configure_file(
    ${CMAKE_SOURCE_DIR}/misc/systemd/dde-control-center.service.in
    ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.control-center.service
    @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.control-center.service
        DESTINATION ${SYSTEMD_USER_UNIT_DIR})

# dev files
file(GLOB HEADERS "${DCC_PROJECT_ROOT_DIR}/include/*")
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center)
install(FILES ${HEADERS} DESTINATION ${INCLUDE_INSTALL_DIR})
if (BUILD_DCC_OLD)
    configure_package_config_file(${DCC_PROJECT_ROOT_DIR}/misc/DdeControlCenterConfigOld.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
        PATH_VARS INCLUDE_INSTALL_DIR
        INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
else()
    configure_package_config_file(${DCC_PROJECT_ROOT_DIR}/misc/DdeControlCenterConfig.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
        PATH_VARS INCLUDE_INSTALL_DIR
        INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
endif()

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfigVersion.cmake"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfigVersion.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter)

install(FILES "${DCC_PROJECT_ROOT_DIR}/misc/DdeControlCenterPluginMacros.cmake" DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter)

install(FILES ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde.controlcenter.metainfo.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)

#dde-grand-search-daemon conf
install(FILES ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde-grand-search.dde-control-center-setting.conf
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/dde-grand-search-daemon/plugins/searcher)

=== src/plugin-commoninfo/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(CommonInfo_Name commonInfo)

pkg_check_modules(DEEPIN_PW_CHECK REQUIRED libdeepin_pw_check)


file(GLOB_RECURSE commonInfo_SRCS
    "operation/*.cpp"
    "operation/*.h"
    "operation/qrc/commoninfo.qrc"
)

add_library(${CommonInfo_Name} MODULE
    ${commonInfo_SRCS}
    operation/grubmenulistmodel.h
    operation/grubmenulistmodel.cpp
)

set(CommonInfo_Libraries
    dde-control-center
    ${DEEPIN_PW_CHECK_INCLUDE_DIRS}
    ${QT_NS}::DBus
    ${DTK_NS}::Gui
)

target_link_libraries(${CommonInfo_Name} PRIVATE
    ${CommonInfo_Libraries}
    ${DEEPIN_PW_CHECK_LIBRARIES}
)

dcc_install_plugin(NAME ${CommonInfo_Name} TARGET ${CommonInfo_Name})

=== src/plugin-datetime/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(pluginName datetime)
file(GLOB_RECURSE datetime_SRCS
    "operation/*.cpp"
    "operation/*.h"
    "operation/timezoneMap/*.h"
    "operation/timezoneMap/*.cpp"
    "operation/qrc/datetime.qrc"
)

add_library(${pluginName} MODULE
    ${datetime_SRCS}
)

find_package(ICU COMPONENTS i18n uc)

set(dateTime_Libraries
    dde-control-center
    ${QT_NS}::DBus
    ${QT_NS}::Concurrent
     ${DTK_NS}::Gui
     ICU::i18n
     ICU::uc
)

target_link_libraries(${pluginName} PRIVATE
    ${dateTime_Libraries}
)

dcc_install_plugin(NAME ${pluginName} TARGET ${pluginName})

=== src/plugin-defaultapp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(DefaultApp_Name defaultapp)
file(GLOB_RECURSE defaultapp_SRCS
    "operation/*.cpp"
)

add_library(${DefaultApp_Name} MODULE
    ${defaultapp_SRCS}
)

set(DefaultApp_Libraries
    dde-control-center
    ${QT_NS}::DBus
)

target_link_libraries(${DefaultApp_Name} PRIVATE
    ${DefaultApp_Libraries}
)

dcc_install_plugin(NAME ${DefaultApp_Name} TARGET ${DefaultApp_Name})

=== src/plugin-keyboard/CMakeLists.txt ===
if (BUILD_PLUGIN)
    set(Plugin_Name keyboard)
    file(GLOB_RECURSE keyboard_SRCS
        "operation/*.h"
        "operation/*.cpp"
        "operation/qrc/keyboard.qrc"
    )
    file(GLOB_RECURSE keyboard_qml_SRCS
        "qml/*.qml"
    )
    # pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)
    add_library(${Plugin_Name} MODULE
        ${keyboard_SRCS}
    )

    set(keyboard_Includes
        src/plugin-keyboard/operation
    )
    set(keyboard_Libraries
        dde-control-center
        ${DTK_NS}::Gui
        ${QT_NS}::DBus
        ${QT_NS}::Gui
        ${QT_NS}::Qml
    )
    target_include_directories(${Plugin_Name} PUBLIC
        ${keyboard_Includes}
    )
    target_link_libraries(${Plugin_Name} PRIVATE
        ${keyboard_Libraries}
    )
    dcc_install_plugin(NAME ${Plugin_Name} TARGET ${Plugin_Name})
    # dcc_handle_plugin_translation(NAME ${Plugin_Name}  QML_FILES ${keyboard_qml_SRCS} SOURCE_FILES ${keyboard_SRCS})
endif()

=== src/plugin-mouse/CMakeLists.txt ===
if (BUILD_PLUGIN)
    set(Mouse_Name mouse)
    file(GLOB_RECURSE mouse_SRCS
        "operation/*.cpp"
        "operation/qrc/mouse.qrc"
    )
    file(GLOB_RECURSE mouse_qml_SRCS
        "qml/*.qml"
    )
    # pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)
    add_library(${Mouse_Name} MODULE
        ${mouse_SRCS}
    )

    set(mouse_Includes
        src/plugin-mouse/operation
    )
    set(mouse_Libraries
        dde-control-center
        ${DTK_NS}::Gui
        ${QT_NS}::DBus
        ${QT_NS}::Qml
        # PkgConfig::QGSettings
    )
    target_include_directories(${Mouse_Name} PUBLIC
        ${mouse_Includes}
    )
    target_link_libraries(${Mouse_Name} PRIVATE
        ${mouse_Libraries}
    )
    dcc_install_plugin(NAME ${Mouse_Name} TARGET ${Mouse_Name})
    # dcc_handle_plugin_translation(NAME ${Mouse_Name}  QML_FILES ${mouse_qml_SRCS} SOURCE_FILES ${mouse_SRCS})
endif()

=== src/plugin-personalization/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(Personalization_Name personalization)
file(GLOB_RECURSE Personalization_SRCS
    "operation/*.cpp"
    "operation/*.hpp"
    "operation/*.h"
    "operation/qrc/personalization.qrc" 
    )

set(personalization_Includes
    src/plugin-personalization/operation
)

add_library(${Personalization_Name} MODULE
    ${Personalization_SRCS}
)

set(Personalization_Libraries
    ${DTK_NS}::Gui
    ${QT_NS}::DBus
    ${QT_NS}::Qml
)

target_include_directories(${Personalization_Name} PUBLIC
    ${personalization_Includes}
)

target_link_libraries(${Personalization_Name} PRIVATE
    ${Personalization_Libraries}
)

dcc_install_plugin(NAME ${Personalization_Name} TARGET ${Personalization_Name})

=== src/plugin-power/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(Power_Name power)
file(GLOB_RECURSE power_SRCS
    "operation/*.cpp"
    "operation/*.h"
    "operation/qrc/power.qrc"
)

add_library(${Power_Name} MODULE
    ${power_SRCS}
)

set(Power_Libraries
    dde-control-center
    ${DTK_NS}::Gui
    ${QT_NS}::DBus
    ${QT_NS}::Concurrent
)

target_link_libraries(${Power_Name} PRIVATE
    ${Power_Libraries}
)

dcc_install_plugin(NAME ${Power_Name} TARGET ${Power_Name})

=== src/plugin-sound/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(Sound_Name sound)
file(GLOB_RECURSE Sound_SRCS
    "operation/*.cpp"
    "operation/qrc/sound.qrc"
)

add_library(${Sound_Name} MODULE
    ${Sound_SRCS}
    operation/soundInteraction.cpp
    operation/soundInteraction.h
    operation/soundDeviceModel.cpp
    operation/soundDeviceModel.h
    operation/soundDeviceData.cpp
    operation/soundDeviceData.h
    operation/port.cpp
    operation/port.h
)

if (DISABLE_SOUND_ADVANCED)
    target_compile_definitions(${Sound_Name} PUBLIC -DDCC_DISABLE_SOUND_ADVANCED)
endif()

set(Sound_Libraries
    dde-control-center
    ${DTK_NS}::Gui
    ${QT_NS}::DBus
)

target_link_libraries(${Sound_Name} PRIVATE
    ${Sound_Libraries}
)

dcc_install_plugin(NAME ${Sound_Name} TARGET ${Sound_Name})
# QML_ROOT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/plugin-sound/qml)

=== src/plugin-systeminfo/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(SystemInfo_Name systemInfo)
file(GLOB_RECURSE systemInfo_SRCS
    "operation/*.cpp"
    "operation/*.h"
    "operation/qrc/systeminfo.qrc"
)

add_library(${SystemInfo_Name} MODULE
    ${systemInfo_SRCS}
    operation/utils.h
)

set(SystemInfo_Libraries
    dde-control-center
    ${QT_NS}::DBus
    ${DTK_NS}::Gui
)

target_link_libraries(${SystemInfo_Name} PRIVATE
    ${SystemInfo_Libraries}
)

dcc_install_plugin(NAME ${SystemInfo_Name} TARGET ${SystemInfo_Name})

=== debian/changelog ===
dde-control-center (6.0.71) unstable; urgency=medium

  * Release 6.0.71
  * fix: adapt to compact mode

 -- Zhang Kun <zhangkun2@uniontech.com>  Thu, 24 Oct 2024 19:09:05 +0800

dde-control-center (6.0.70) unstable; urgency=medium

  * chore: add translations about time format
  * chore: add the country feature
  * fix: Modify the style of the image source list widget
  * chore: Add 'qt6-declarative-private-dev' dependency in control
  * fix: Fixed the problem of obtaining the path of the boot menu theme image
  * feat: 蓝牙图标改成和dde-tray-loader一样的内建图标
  * feat: Control Center-General Module Design and Transformation
  * feat: add dccrepeater
  * feat: implement personalized module

 -- Yutao Meng <mengyutao@deepin.org>  Wed, 16 Oct 2024 17:29:08 +0800

dde-control-center (6.0.69) unstable; urgency=medium

  * Display compact mode

 -- Zhang Kun <zhangkun2@uniontech.com>  Sat, 12 Oct 2024 10:28:49 +0800

dde-control-center (6.0.68) unstable; urgency=medium

  * release 6.0.68

 -- Mike Chen <chenke@deepin.org>  Fri, 27 Sep 2024 14:11:00 +0800

dde-control-center (6.0.67) unstable; urgency=medium

  * fix: incorrect bluetooth device icon theme type

 -- xionglinlin <xionglinlin@uniontech.com>  Wed, 25 Sep 2024 17:58:11 +0800

dde-control-center (6.0.66) unstable; urgency=medium

  * release 6.0.66
  * feat: remove linglong update
  * feat: add compact mode and hide it by default

 -- Zhang Kun <zhangkun2@uniontech.com>  Thu, 12 Sep 2024 15:49:46 +0800

dde-control-center (6.0.65) unstable; urgency=medium

  * fix: need click twice to set hidden dock plugin visible

 -- Yutao Meng <mengyutao@deepin.org>  Wed, 04 Sep 2024 16:47:38 +0800

dde-control-center (6.0.64) unstable; urgency=medium

  * bump version to 6.0.64

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 29 Aug 2024 10:34:15 +0800

dde-control-center (6.0.63) unstable; urgency=medium

  * fix: set search popup distance from searchLineEdit to 8 (#1675)(Issue: 10398)

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 22 Aug 2024 11:02:02 +0800

=== debian/control ===
Source: dde-control-center
Section: admin
Priority: optional
Maintainer: Deepin Sysdev <sysdev@deepin.com>
Build-Depends:
 debhelper-compat (= 12),
 pkg-config,
 cmake,
 qt6-base-dev,
 qt6-declarative-dev,
 qt6-tools-dev,
 qt6-declarative-private-dev,
 libdtkcommon-dev,
 libdtk6gui-dev,
 libdtk6core-dev,
 doxygen,
 libgtest-dev,
 extra-cmake-modules,
 libqt6svg6,
 deepin-gettext-tools,
 qml6-module-qtquick-layouts,
 qml6-module-qtquick-window,
 qml6-module-qt-labs-qmlmodels,
 systemd,
 qtbase5-dev,
 qtbase5-private-dev,
 qttools5-dev-tools,
 libdtkwidget-dev,
 libdtkcore-dev(>>5.6.18),
 libdtkcore5-bin,
 qtmultimedia5-dev,
 libdareader-dev,
 libdeepin-pw-check-dev,
 libpolkit-qt5-1-dev,
 libgsettings-qt-dev,
 libicu-dev,
 libwayland-dev,
Standards-Version: 4.5.0
Homepage: https://github.com/linuxdeepin/dde-control-center

Package: dde-control-center
Architecture: any
Depends:
 ${shlibs:Depends}, ${misc:Depends},
 qml6-module-qtquick-layouts,
 qml6-module-qtquick-window,
 qml6-module-qt-labs-qmlmodels,
 libdtk6declarative,
 netselect,
Description: New control center for Deepin Desktop Environment,
 Integrated control center with rich functions,Besides providing rich
 system setting items, the function level is simple, the logic is clear,
 the user can easily set the system, and the learning cost is low,
 Provide users with automatic update system and developer mode to meet
 the various needs of users for the operating system.
 abrecovery -restore system, Determine whether the system is restored
 reboot-reminder-dialog -Update restart, Confirm whether to restart the system
 after the completion of the update.
 DDE Control Center is the control panel of Deepin Desktop Environment.

Package: dde-control-center-dev
Architecture: any
Depends: dde-control-center (= ${binary:Version}), ${misc:Depends}
Description: New control center for Deepin Desktop Environment - development files
 DDE Control Center is the control panel of Deepin Desktop Environment.

Package: dde-control-center-doc
Architecture: any
Depends: dde-control-center (= ${binary:Version}), ${misc:Depends}
Description: dde-control-center (document)
 This package contains the doc files of dde-control-center

## dde-control-center 6.0.75+deepin0+rb1

=== CMakeLists.txt ===
--- 
+++ 
@@ -149,7 +149,7 @@
 # Find the library
 find_package(PkgConfig REQUIRED)
 find_package(${DTK_NS} REQUIRED COMPONENTS Core Gui  )
-find_package(${QT_NS} COMPONENTS Core Quick Gui Network DBus Concurrent Test LinguistTools REQUIRED)
+find_package(${QT_NS} COMPONENTS Core Quick Gui Network DBus Concurrent Test LinguistTools Multimedia REQUIRED)
 find_package(GTest REQUIRED)
 find_package(Threads REQUIRED)
 
@@ -171,8 +171,10 @@
     -lgcov
     Threads::Threads
     GTest::gtest
-    Qt::Test
+    ${QT_NS}::Test
 )
+
+set(DCC_FRAME_Library dde-control-center_frame)
 
 add_subdirectory(src/dde-control-center)
 #--------------------------plugins--------------------------
@@ -187,3 +189,4 @@
 add_subdirectory(src/plugin-touchscreen)
 add_subdirectory(src/plugin-datetime)
 add_subdirectory(src/plugin-wacom)
+add_subdirectory(src/plugin-bluetooth)

=== src/dde-control-center/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,7 @@
 cmake_minimum_required(VERSION 3.18)
 
 #--------------------------frame--------------------------
-set(DCC_Library dde-control-center_frame)
-set(DCCFrame_Name ${DCC_Library})
+set(DCCFrame_Name ${DCC_FRAME_Library})
 file(GLOB DCCFrame_SRCS
     "${DCC_PROJECT_ROOT_DIR}/include/*.h"
     "frame/*.cpp"
@@ -73,12 +72,12 @@
 )
 
 set(Control_Center_Libraries
-    ${DCC_Library}
+    ${DCC_FRAME_Library}
     ${DTK_NS}::Gui
-    Qt::Gui
-    Qt::DBus
-    Qt::Concurrent
-    Qt::Quick
+    ${QT_NS}::Gui
+    ${QT_NS}::DBus
+    ${QT_NS}::Concurrent
+    ${QT_NS}::Quick
 )
 
 target_link_libraries(${Control_Center_Name} PRIVATE

=== src/plugin-personalization/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(LIB_NAME personalization)

find_package(Qt6 REQUIRED COMPONENTS WaylandClient)

set(Enable_TreelandSupport ON CACHE BOOL "Enable Treeland Support")

if (Enable_TreelandSupport)
find_package(TreelandProtocols REQUIRED)
endif()

file(GLOB_RECURSE Personalization_SRCS
    "operation/*.cpp"
    "operation/*.hpp"
    "operation/*.h"
    "operation/qrc/personalization.qrc"
    )

set(personalization_Includes
    src/plugin-personalization/operation
)

add_library(${LIB_NAME} MODULE
    ${Personalization_SRCS}
)

if (Enable_TreelandSupport)
qt6_generate_wayland_protocol_client_sources(${LIB_NAME} FILES
    ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-personalization-manager-v1.xml
)

target_compile_definitions(${LIB_NAME} PRIVATE Enable_Treeland)
endif()


set(Personalization_Libraries
    ${DCC_FRAME_Library}
    ${DTK_NS}::Gui
    ${QT_NS}::DBus
    ${QT_NS}::Qml
    ${QT_NS}::WaylandClientPrivate
)

target_include_directories(${LIB_NAME} PUBLIC
    ${personalization_Includes}
)

target_link_libraries(${LIB_NAME} PRIVATE
    ${Personalization_Libraries}
)

dcc_install_plugin(NAME ${LIB_NAME} TARGET ${LIB_NAME})

=== src/plugin-sound/CMakeLists.txt ===
--- 
+++ 
@@ -22,9 +22,10 @@
 endif()
 
 set(Sound_Libraries
-    dde-control-center
+    ${DCC_FRAME_Library}
     ${DTK_NS}::Gui
     ${QT_NS}::DBus
+    ${QT_NS}::Multimedia
 )
 
 target_link_libraries(${Sound_Name} PRIVATE

=== src/plugin-touchscreen/CMakeLists.txt ===
if (BUILD_PLUGIN)
    set(touchscreen_Name touchscreen)
    file(GLOB_RECURSE touchscreen_SRCS
        "operation/*.cpp"
        "operation/qrc/touchscreen.qrc"
    )
    file(GLOB_RECURSE touchscreen_qml_SRCS
        "qml/*.qml"
    )
    # pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)
    add_library(${touchscreen_Name} MODULE
        ${touchscreen_SRCS}
    )

    set(touchscreen_Includes
        src/plugin-touchscreen/operation
    )
    set(touchscreen_Libraries
        ${DCC_FRAME_Library}
        ${DTK_NS}::Gui
        ${QT_NS}::DBus
        ${QT_NS}::Qml
    )
    target_include_directories(${touchscreen_Name} PUBLIC
        ${touchscreen_Includes}
    )
    target_link_libraries(${touchscreen_Name} PRIVATE
        ${touchscreen_Libraries}
    )
    dcc_install_plugin(NAME ${touchscreen_Name} TARGET ${touchscreen_Name})
    # dcc_handle_plugin_translation(NAME ${touchscreen_Name}  QML_FILES ${touchscreen_qml_SRCS} SOURCE_FILES ${touchscreen_SRCS})
endif()

=== src/dde-control-center/frame/plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

set(DCCQmlPlugin_Name dde-control-center-plugin)
set(URI "org.deepin.dcc")
string(REPLACE "." "/" URI_PATH ${URI})

file(GLOB DCCQmlPlugin_SRCS
    "src/*.h"
    "src/*.cpp"
    "src/qrc/dcc.qrc"
)

file(GLOB QML_PATHS
    "*.qml"
    "*.js"
)

foreach(FILE_PATH ${QML_PATHS})
    string(REGEX REPLACE ".+/(.+)" "\\1" FILE_NAME ${FILE_PATH})
    list(APPEND DCCQmlPlugin_CONTROLS ${FILE_NAME})
endforeach(FILE_PATH)

qt_add_qml_module(${DCCQmlPlugin_Name}
    PLUGIN_TARGET ${DCCQmlPlugin_Name}
    URI ${URI}
    VERSION "1.0"
    SHARED
    NO_GENERATE_PLUGIN_SOURCE
    NO_PLUGIN_OPTIONAL
    QML_FILES
        ${DCCQmlPlugin_CONTROLS}
    SOURCES
        ${DCCQmlPlugin_SRCS}
    OUTPUT_DIRECTORY
        "${PROJECT_BINARY_DIR}/lib/${URI_PATH}"
)

target_include_directories(${DCCQmlPlugin_Name} PRIVATE
    include
)

set(DCCQmlPlugin_Libraries
    ${QT_NS}::Gui
    ${QT_NS}::Quick
    ${DCC_FRAME_Library}
)

target_link_libraries(${DCCQmlPlugin_Name} PRIVATE
    ${DCCQmlPlugin_Libraries}
)
# set(QML_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/qml" CACHE STRING "Qml plugin install directory")
set(QML_INSTALL_DIR ${DCC_INSTALL_DIR})
install(DIRECTORY "${PROJECT_BINARY_DIR}/lib/${URI_PATH}/" DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}/")

=== debian/changelog ===
dde-control-center (6.0.75+deepin0+rb1) unstable; urgency=medium

  * release 6.0.75

 -- xionglinlin <xionglinlin@uniontech.com>  Wed, 13 Nov 2024 11:41:03 +0800

dde-control-center (6.0.74) UNRELEASED; urgency=medium

  * release 6.0.74

 -- Zhangkun <zhangkun2@uniontech.com>  Fri, 08 Nov 2024 14:26:12 +0800

dde-control-center (6.0.73) unstable; urgency=medium

  * release 6.0.73 

 -- Zhangkun <zhangkun2@uniontech.com>  Thu, 07 Nov 2024 15:58:29 +0800

dde-control-center (6.0.72) unstable; urgency=medium

  * release 6.0.72

 -- Mike Chen <chenke@deepin.org>  Thu, 31 Oct 2024 13:36:34 +0800

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  qt6-tools-dev,
  qt6-declarative-private-dev,
  libdtkcommon-dev,
- libdtk6gui-dev,
+ libdtk6gui-dev(>=6.0.21),
  libdtk6core-dev,
  doxygen,
  libgtest-dev,
@@ -21,6 +21,10 @@
  qml6-module-qtquick-layouts,
  qml6-module-qtquick-window,
  qml6-module-qt-labs-qmlmodels,
+ qt6-wayland-dev,
+ qt6-wayland-private-dev,
+ qt6-wayland-dev-tools,
+ treeland-protocols,
  systemd,
  qtbase5-dev,
  qtbase5-private-dev,
@@ -29,6 +33,7 @@
  libdtkcore-dev(>>5.6.18),
  libdtkcore5-bin,
  qtmultimedia5-dev,
+ qt6-multimedia-dev,
  libdareader-dev,
  libdeepin-pw-check-dev,
  libpolkit-qt5-1-dev,
@@ -45,6 +50,7 @@
  qml6-module-qtquick-layouts,
  qml6-module-qtquick-window,
  qml6-module-qt-labs-qmlmodels,
+ qml6-module-qtquick-dialogs,
  libdtk6declarative,
  netselect,
 Description: New control center for Deepin Desktop Environment,
